| OrbbecSDK 1.10.18 OrbbecSDK: Software-Development-Kit for Orbbec 3D Cameras

Loading...
Searching...
No Matches
Static Public Member Functions | List of all members
ob::CoordinateTransformHelper Class Reference

`#include <Utils.hpp>`

## Static Public Member Functions
static bool | calibration3dTo3d (const OBCalibrationParam calibrationParam, const OBPoint3f sourcePoint3f, const OBSensorType sourceSensorType, const OBSensorType targetSensorType, OBPoint3f *targetPoint3f)
| Transform a 3d point of a source coordinate system into a 3d point of the target coordinate system.
static bool | calibration2dTo3d (const OBCalibrationParam calibrationParam, const OBPoint2f sourcePoint2f, const float sourceDepthPixelValue, const OBSensorType sourceSensorType, const OBSensorType targetSensorType, OBPoint3f *targetPoint3f)
| Transform a 2d pixel coordinate with an associated depth value of the source camera into a 3d point of the target coordinate system.
static bool | calibration2dTo3dUndistortion (const OBCalibrationParam calibrationParam, const OBPoint2f sourcePoint2f, const float sourceDepthPixelValue, const OBSensorType sourceSensorType, const OBSensorType targetSensorType, OBPoint3f *targetPoint3f)
| Transform a 2d pixel coordinate with an associated depth value of the source camera into a 3d point of the target coordinate system.
static bool | calibration3dTo2d (const OBCalibrationParam calibrationParam, const OBPoint3f sourcePoint3f, const OBSensorType sourceSensorType, const OBSensorType targetSensorType, OBPoint2f *targetPoint2f)
| Transform a 3d point of a source coordinate system into a 2d pixel coordinate of the target camera.
static bool | calibration2dTo2d (const OBCalibrationParam calibrationParam, const OBPoint2f sourcePoint2f, const float sourceDepthPixelValue, const OBSensorType sourceSensorType, const OBSensorType targetSensorType, OBPoint2f *targetPoint2f)
| Transform a 2d pixel coordinate with an associated depth value of the source camera into a 2d pixel coordinate of the target camera.
static std::shared_ptr< ob::Frame > | transformationDepthFrameToColorCamera (std::shared_ptr< ob::Device > device, std::shared_ptr< ob::Frame > depthFrame, uint32_t targetColorCameraWidth, uint32_t targetColorCameraHeight)
| Transforms the depth frame into the geometry of the color camera.
static bool | transformationInitXYTables (const OBCalibrationParam calibrationParam, const OBSensorType sensorType, float *data, uint32_t *dataSize, OBXYTables *xyTables)
| Init transformation tables.
static void | transformationDepthToPointCloud (OBXYTables *xyTables, const void *depthImageData, void *pointCloudData)
| Transform depth image to point cloud data.
static void | transformationDepthToRGBDPointCloud (OBXYTables *xyTables, const void *depthImageData, const void *colorImageData, void *pointCloudData)
| Transform depth image to RGBD point cloud data.

## Detailed Description

Definition at line 13 of file Utils.hpp.

## Member Function Documentation

## ◆ calibration3dTo3d()

static bool ob::CoordinateTransformHelper::calibration3dTo3d | ( | const OBCalibrationParam | calibrationParam,
|  | const OBPoint3f | sourcePoint3f,
|  | const OBSensorType | sourceSensorType,
|  | const OBSensorType | targetSensorType,
|  | OBPoint3f * | targetPoint3f
| ) |  |
| static

Transform a 3d point of a source coordinate system into a 3d point of the target coordinate system.

Parameters

  calibrationParam | Device calibration param,see pipeline::getCalibrationParam
  sourcePoint3f | Source 3d point value
  sourceSensorType | Source sensor type
  targetSensorType | Target sensor type
  targetPoint3f | Target 3d point value

Returns
  bool Transform result

## ◆ calibration2dTo3d()

static bool ob::CoordinateTransformHelper::calibration2dTo3d | ( | const OBCalibrationParam | calibrationParam,
|  | const OBPoint2f | sourcePoint2f,
|  | const float | sourceDepthPixelValue,
|  | const OBSensorType | sourceSensorType,
|  | const OBSensorType | targetSensorType,
|  | OBPoint3f * | targetPoint3f
| ) |  |
| static

Transform a 2d pixel coordinate with an associated depth value of the source camera into a 3d point of the target coordinate system.

Parameters

  calibrationParam | Device calibration param,see pipeline::getCalibrationParam
  sourcePoint2f | Source 2d point value
  sourceDepthPixelValue | The depth of sourcePoint2f in millimeters
  sourceSensorType | Source sensor type
  targetSensorType | Target sensor type
  targetPoint3f | Target 3d point value

Returns
  bool Transform result

## ◆ calibration2dTo3dUndistortion()

static bool ob::CoordinateTransformHelper::calibration2dTo3dUndistortion | ( | const OBCalibrationParam | calibrationParam,
|  | const OBPoint2f | sourcePoint2f,
|  | const float | sourceDepthPixelValue,
|  | const OBSensorType | sourceSensorType,
|  | const OBSensorType | targetSensorType,
|  | OBPoint3f * | targetPoint3f
| ) |  |
| static

Transform a 2d pixel coordinate with an associated depth value of the source camera into a 3d point of the target coordinate system.

This function uses undistortion, which may result in longer processing time.

Parameters

  calibrationParam | Device calibration param,see pipeline::getCalibrationParam
  sourcePoint2f | Source 2d point value
  sourceDepthPixelValue | The depth of sourcePoint2f in millimeters
  sourceSensorType | Source sensor type
  targetSensorType | Target sensor type
  targetPoint3f | Target 3d point value

Returns
  bool Transform result

## ◆ calibration3dTo2d()

static bool ob::CoordinateTransformHelper::calibration3dTo2d | ( | const OBCalibrationParam | calibrationParam,
|  | const OBPoint3f | sourcePoint3f,
|  | const OBSensorType | sourceSensorType,
|  | const OBSensorType | targetSensorType,
|  | OBPoint2f * | targetPoint2f
| ) |  |
| static

Transform a 3d point of a source coordinate system into a 2d pixel coordinate of the target camera.

Parameters

  calibrationParam | Device calibration param,see pipeline::getCalibrationParam
  sourcePoint3f | Source 3d point value
  sourceSensorType | Source sensor type
  targetSensorType | Target sensor type
  targetPoint2f | Target 2d point value

Returns
  bool Transform result

## ◆ calibration2dTo2d()

static bool ob::CoordinateTransformHelper::calibration2dTo2d | ( | const OBCalibrationParam | calibrationParam,
|  | const OBPoint2f | sourcePoint2f,
|  | const float | sourceDepthPixelValue,
|  | const OBSensorType | sourceSensorType,
|  | const OBSensorType | targetSensorType,
|  | OBPoint2f * | targetPoint2f
| ) |  |
| static

Transform a 2d pixel coordinate with an associated depth value of the source camera into a 2d pixel coordinate of the target camera.

Parameters

  calibrationParam | Device calibration param,see pipeline::getCalibrationParam
  sourcePoint2f | Source 2d point value
  sourceDepthPixelValue | The depth of sourcePoint2f in millimeters
  sourceSensorType | Source sensor type
  targetSensorType | Target sensor type
  targetPoint2f | Target 2d point value

Returns
  bool Transform result

## ◆ transformationDepthFrameToColorCamera()

static std::shared_ptr< ob::Frame > ob::CoordinateTransformHelper::transformationDepthFrameToColorCamera | ( | std::shared_ptr< ob::Device > | device,
|  | std::shared_ptr< ob::Frame > | depthFrame,
|  | uint32_t | targetColorCameraWidth,
|  | uint32_t | targetColorCameraHeight
| ) |  |
| static

Transforms the depth frame into the geometry of the color camera.

Parameters

  device | Device handle
  depthFrame | Input depth frame
  targetColorCameraWidth | Target color camera width
  targetColorCameraHeight | Target color camera height

Returns
  std::shared_ptr<ob::Frame> Transformed depth frame

## ◆ transformationInitXYTables()

static bool ob::CoordinateTransformHelper::transformationInitXYTables | ( | const OBCalibrationParam | calibrationParam,
|  | const OBSensorType | sensorType,
|  | float * | data,
|  | uint32_t * | dataSize,
|  | OBXYTables * | xyTables
| ) |  |
| static

Init transformation tables.

Parameters

  calibrationParam | Device calibration param,see pipeline::getCalibrationParam
  sensorType | sensor type
  data | input data,needs to be allocated externally.During initialization, the external allocation size is 'dataSize', for example, dataSize = 1920 * 1080 * 2*sizeof(float) (1920 * 1080 represents the image resolution, and 2 represents two LUTs, one for x-coordinate and one for y-coordinate).
  dataSize | input data size
  xyTables | output xy tables

Returns
  bool Transform result

## ◆ transformationDepthToPointCloud()

static void ob::CoordinateTransformHelper::transformationDepthToPointCloud | ( | OBXYTables * | xyTables,
|  | const void * | depthImageData,
|  | void * | pointCloudData
| ) |  |
| static

Transform depth image to point cloud data.

Parameters

  xyTables | input xy tables,see CoordinateTransformHelper::transformationInitXYTables
  depthImageData | input depth image data
  pointCloudData | output point cloud data

## ◆ transformationDepthToRGBDPointCloud()

static void ob::CoordinateTransformHelper::transformationDepthToRGBDPointCloud | ( | OBXYTables * | xyTables,
|  | const void * | depthImageData,
|  | const void * | colorImageData,
|  | void * | pointCloudData
| ) |  |
| static

Transform depth image to RGBD point cloud data.

Parameters

  xyTables | input xy tables,see CoordinateTransformHelper::transformationInitXYTables
  depthImageData | input depth image data
  colorImageData | input color image data (only RGB888 support)
  pointCloudData | output RGBD point cloud data

The documentation for this class was generated from the following file:

- E:/Projects/Jenkins/workspace/OrbbecSDK/libobsensor/include/libobsensor/hpp/Utils.hpp